/*
 * $Header: /cvs/CVS_LEBA/external/openmap/openmap/src/openmap/com/bbn/openmap/plugin/wms/BasicWmsLayer.java,v 1.2 2006/04/27 05:58:25 pitek Exp $
 *
 */

package com.bbn.openmap.plugin.wms;

import java.util.ArrayList;
import java.util.List;

import com.bbn.openmap.wms.DefaultWmsLayerStyle;

/**
 * Data of a single WMS layer.
 * @author tomk (http://www.ctm.gdynia.pl)
 */
public class BasicWmsLayer {

    //~ Instance variables ---------------------------------------------------------------------------------------------

    private boolean visible;
    private String name;
    private String title;
    private String abstractt;
    private List<DefaultWmsLayerStyle> styles = new ArrayList<DefaultWmsLayerStyle>();
    int currentStyleIndex = 0;

    //~ Constructors ---------------------------------------------------------------------------------------------------

    /**
     * Creates a new instance of WMS
     */
    public BasicWmsLayer() {
    }

    //~ Methods --------------------------------------------------------------------------------------------------------

    /**
     * @return
     */
    public DefaultWmsLayerStyle getCurrentStyle() {
        return (currentStyleIndex < styles.size()) ? styles.get(currentStyleIndex) : null;
    }

    /**
     * @return
     */
    public int getCurrentStyleIndex() {
        return currentStyleIndex;
    }

    /**
     * @param currentStyleIndex
     */
    public void setCurrentStyleIndex(int currentStyleIndex) {
        this.currentStyleIndex = currentStyleIndex;
    }

    /**
     * @return
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return
     */
    public String getTitle() {
        return title;
    }

    /**
     * @param title
     */
    public void setTitle(String title) {
        this.title = title;
    }

    /**
     * @return
     */
    public String getAbstract() {
        return abstractt;
    }

    /**
     * @param abstractt
     */
    public void setAbstract(String abstractt) {
        this.abstractt = abstractt;
    }

    /**
     * @return
     */
    public List<DefaultWmsLayerStyle> getStyles() {
        return styles;
    }

    /**
     * @param styles
     */
    public void setStyles(List<DefaultWmsLayerStyle> styles) {
        this.styles = styles;
    }

    /**
     * @return
     */
    public boolean isVisible() {
        return visible;
    }

    /**
     * @param visible
     */
    public void setVisible(boolean visible) {
        this.visible = visible;
    }

    /**
     * @param name
     * @param title
     * @param abstractt
     * @return
     */
    public DefaultWmsLayerStyle addStyle(String name, String title, String abstractt) {
        DefaultWmsLayerStyle style = new DefaultWmsLayerStyle(name, title, abstractt);
        styles.add(style);
        return style;
    }
}
